#include "utils.PRO2"
#include "Arbre.hpp"
#include "ArbIOint.hpp"

#include <list>
#include <queue>

list<int> preordre(Arbre<int>& a)
/* Pre: a=A */
{
  if (a.es_buit()) return list<int>();
  else {
    int n=a.arrel();
    Arbre<int> a1;
    Arbre<int> a2;
    a.fills(a1,a2);
    list<int> l=preordre(a1);
    list<int> m=preordre(a2);
    l.insert(l.begin(),n);
    l.splice(l.end(),m);
    return l;
  }
}
/* Post: retorna la llista de nodes d'A en recorreguts en preordre */

list<int> inordre(Arbre<int>& a)
/* Pre: a=A */
{
  if (a.es_buit()) return list<int>();
  else {
    int n=a.arrel();
    Arbre<int> a1;
    Arbre<int> a2;
    a.fills(a1,a2);
    list<int> l=inordre(a1);
    list<int> m=inordre(a2);
    l.insert(l.end(),n);
    l.splice(l.end(),m);
    return l;
  }
}
/* Post: retorna la llista de nodes d'A en recorreguts en inordre */


list<int> postordre(Arbre<int>& a)
/* Pre: a=A */
{
  if (a.es_buit()) return list<int>();
  else {
    int n=a.arrel();
    Arbre<int> a1;
    Arbre<int> a2;
    a.fills(a1,a2);
    list<int> l=postordre(a1);
    list<int> m=postordre(a2);
    l.splice(l.end(),m);
    l.insert(l.end(),n);
    return l;
  }
}
/* Post: retorna la llista de nodes d'A en recorreguts en postordre */


list<int> nivells(Arbre<int>& a)
/* Pre: a=A */
{
  list<int> l;
  queue<Arbre<int> > q;
  q.push(a);
  while (not q.empty()){  
    Arbre<int> b=q.front();
    q.pop();
    if (not b.es_buit()) {
      l.insert(l.end(),b.arrel());
      Arbre<int> b1;
      Arbre<int> b2;
      b.fills(b1,b2);
      q.push(b1);
      q.push(b2);
    }
  }
  return l;
}
/* Post: retorna la llista de nodes d'A en recorreguts per nivells */



int main(){
  Arbre <int> a;
  llegir_arbre_int(a,0);
  Arbre <int> b=a;
  list<int> l=preordre(b);
  for (list<int>::iterator it=l.begin(); it!=l.end(); ++it) 
    cout << *it << " ";
  cout << endl;
  b=a;
  l=inordre(b);
  for (list<int>::iterator it=l.begin(); it!=l.end(); ++it) 
    cout << *it << " ";
  cout << endl;
  b=a;
  l=postordre(b);
  for (list<int>::iterator it=l.begin(); it!=l.end(); ++it) 
    cout << *it << " ";
  cout << endl;
  b=a;
  l=nivells(b);
  for (list<int>::iterator it=l.begin(); it!=l.end(); ++it) 
    cout << *it << " ";
  cout << endl;
}
